commit 63d91069ba8a9f1dc8bfa56ebfc10903a999f1cb
Author: Jonathan Wakely <jwakely@redhat.com>
Date:   Wed Sep 15 22:53:35 2021

    libstdc++: Add missing 'constexpr' to std::tuple [PR102270]
    
    Signed-off-by: Jonathan Wakely <jwakely@redhat.com>
    
    libstdc++-v3/ChangeLog:
    
            PR libstdc++/102270
            * include/std/tuple (_Head_base, _Tuple_impl): Add
            _GLIBCXX20_CONSTEXPR to allocator-extended constructors.
            (tuple<>::swap(tuple&)): Add _GLIBCXX20_CONSTEXPR.
            * testsuite/20_util/tuple/cons/102270.C: New test.
    
    (cherry picked from commit 734b2c2eedca50d966e22540fc136158c3633393)

diff --git a/libstdc++-v3/include/std/tuple b/libstdc++-v3/include/std/tuple
index 6953f8715d7..a9de356a05e 100644
--- a/libstdc++-v3/include/std/tuple
+++ b/libstdc++-v3/include/std/tuple
@@ -95,10 +95,12 @@ _GLIBCXX_BEGIN_NAMESPACE_VERSION
       : _M_head_impl() { }
 
       template<typename _Alloc>
+	_GLIBCXX20_CONSTEXPR
 	_Head_base(allocator_arg_t, __uses_alloc1<_Alloc> __a)
 	: _M_head_impl(allocator_arg, *__a._M_a) { }
 
       template<typename _Alloc>
+	_GLIBCXX20_CONSTEXPR
 	_Head_base(allocator_arg_t, __uses_alloc2<_Alloc> __a)
 	: _M_head_impl(*__a._M_a) { }
 
@@ -108,11 +110,13 @@ _GLIBCXX_BEGIN_NAMESPACE_VERSION
 	: _M_head_impl(std::forward<_UHead>(__uhead)) { }
 
       template<typename _Alloc, typename _UHead>
+	_GLIBCXX20_CONSTEXPR
 	_Head_base(__uses_alloc1<_Alloc> __a, _UHead&& __uhead)
 	: _M_head_impl(allocator_arg, *__a._M_a, std::forward<_UHead>(__uhead))
 	{ }
 
       template<typename _Alloc, typename _UHead>
+	_GLIBCXX20_CONSTEXPR
 	_Head_base(__uses_alloc2<_Alloc> __a, _UHead&& __uhead)
 	: _M_head_impl(std::forward<_UHead>(__uhead), *__a._M_a) { }
 
@@ -142,26 +146,32 @@ _GLIBCXX_BEGIN_NAMESPACE_VERSION
         constexpr _Head_base(_UHead&& __h)
 	: _Head(std::forward<_UHead>(__h)) { }
 
+      _GLIBCXX20_CONSTEXPR
       _Head_base(allocator_arg_t, __uses_alloc0)
       : _Head() { }
 
       template<typename _Alloc>
+	_GLIBCXX20_CONSTEXPR
 	_Head_base(allocator_arg_t, __uses_alloc1<_Alloc> __a)
 	: _Head(allocator_arg, *__a._M_a) { }
 
       template<typename _Alloc>
+	_GLIBCXX20_CONSTEXPR
 	_Head_base(allocator_arg_t, __uses_alloc2<_Alloc> __a)
 	: _Head(*__a._M_a) { }
 
       template<typename _UHead>
+	_GLIBCXX20_CONSTEXPR
 	_Head_base(__uses_alloc0, _UHead&& __uhead)
 	: _Head(std::forward<_UHead>(__uhead)) { }
 
       template<typename _Alloc, typename _UHead>
+	_GLIBCXX20_CONSTEXPR
 	_Head_base(__uses_alloc1<_Alloc> __a, _UHead&& __uhead)
 	: _Head(allocator_arg, *__a._M_a, std::forward<_UHead>(__uhead)) { }
 
       template<typename _Alloc, typename _UHead>
+	_GLIBCXX20_CONSTEXPR
 	_Head_base(__uses_alloc2<_Alloc> __a, _UHead&& __uhead)
 	: _Head(std::forward<_UHead>(__uhead), *__a._M_a) { }
 
@@ -194,10 +204,12 @@ _GLIBCXX_BEGIN_NAMESPACE_VERSION
       : _M_head_impl() { }
 
       template<typename _Alloc>
+	_GLIBCXX20_CONSTEXPR
 	_Head_base(allocator_arg_t, __uses_alloc1<_Alloc> __a)
 	: _M_head_impl(allocator_arg, *__a._M_a) { }
 
       template<typename _Alloc>
+	_GLIBCXX20_CONSTEXPR
 	_Head_base(allocator_arg_t, __uses_alloc2<_Alloc> __a)
 	: _M_head_impl(*__a._M_a) { }
 
@@ -207,11 +219,13 @@ _GLIBCXX_BEGIN_NAMESPACE_VERSION
 	: _M_head_impl(std::forward<_UHead>(__uhead)) { }
 
       template<typename _Alloc, typename _UHead>
+	_GLIBCXX20_CONSTEXPR
 	_Head_base(__uses_alloc1<_Alloc> __a, _UHead&& __uhead)
 	: _M_head_impl(allocator_arg, *__a._M_a, std::forward<_UHead>(__uhead))
 	{ }
 
       template<typename _Alloc, typename _UHead>
+	_GLIBCXX20_CONSTEXPR
 	_Head_base(__uses_alloc2<_Alloc> __a, _UHead&& __uhead)
 	: _M_head_impl(std::forward<_UHead>(__uhead), *__a._M_a) { }
 
@@ -463,6 +477,7 @@ _GLIBCXX_BEGIN_NAMESPACE_VERSION
 	{ }
 
       template<typename _Alloc>
+	_GLIBCXX20_CONSTEXPR
 	_Tuple_impl(allocator_arg_t __tag, const _Alloc& __a,
 		    const _Head& __head)
 	: _Base(__use_alloc<_Head, _Alloc, const _Head&>(__a), __head)
@@ -951,6 +966,7 @@ _GLIBCXX_BEGIN_NAMESPACE_VERSION
     class tuple<>
     {
     public:
+      _GLIBCXX20_CONSTEXPR
       void swap(tuple&) noexcept { /* no-op */ }
       // We need the default since we're going to define no-op
       // allocator constructors.
diff --git a/libstdc++-v3/testsuite/20_util/tuple/cons/102270.C b/libstdc++-v3/testsuite/20_util/tuple/cons/102270.C
new file mode 100644
index 00000000000..998329817c7
--- /dev/null
+++ b/libstdc++-v3/testsuite/20_util/tuple/cons/102270.C
@@ -0,0 +1,61 @@
+// { dg-options "-std=gnu++20" }
+// { dg-do compile { target c++20 } }
+
+#include <tuple>
+
+// PR libstdc++/102270 - std::tuple<>::swap missing constexpr specifier
+
+constexpr bool swap_empty_tuple()
+{
+  std::tuple<> t, u;
+  t.swap(u);
+  return true;
+}
+static_assert( swap_empty_tuple() );
+
+#include <testsuite_allocator.h>
+
+constexpr bool construct_using_allocator()
+{
+  using Alloc = __gnu_test::SimpleAllocator<int>;
+
+  Alloc a;
+  const int i = 0;
+
+  struct X0a {
+    using allocator_type = Alloc;
+    /* not constexpr */ X0a() { }
+    constexpr X0a(allocator_type) { }
+  };
+  std::tuple<X0a> t0a(std::allocator_arg, a);
+  std::tuple<X0a, X0a> t00a(std::allocator_arg, a);
+
+  struct X0b {
+    using allocator_type = Alloc;
+    /* not constexpr */ X0b() { }
+    constexpr X0b(std::allocator_arg_t, allocator_type) { }
+  };
+  std::tuple<X0b> t0b(std::allocator_arg, a);
+  std::tuple<X0b, X0b> t00b(std::allocator_arg, a);
+
+  struct X1a {
+    using allocator_type = Alloc;
+    /* not constexpr */ X1a(int) { }
+    constexpr X1a(int, allocator_type) { }
+  };
+  std::tuple<X1a> t1a(std::allocator_arg, a, 1);
+  std::tuple<X1a, X1a> t11a(std::allocator_arg, a, 1, i);
+
+  struct X1b {
+    using allocator_type = Alloc;
+    /* not constexpr */ X1b(int) { }
+    constexpr X1b(std::allocator_arg_t, allocator_type, int) { }
+  };
+  std::tuple<X1b> t1b(std::allocator_arg, a, 1);
+  std::tuple<X1b, X1b> t11b(std::allocator_arg, a, 1, i);
+
+  std::tuple<X1a, X1a, X1b, X1b> t1a1b(std::allocator_arg, a, 1, i, 1, i);
+
+  return true;
+}
+static_assert( construct_using_allocator() );

